// KeypadManager.h : Declaration of the CKeypadManager

#ifndef __KEYPADMANAGER_H_
#define __KEYPADMANAGER_H_

#include "resource.h"       // main symbols

#define MAXKEYS 64

struct ThreadParam
{
	long delay;
};

/////////////////////////////////////////////////////////////////////////////
// CKeypadManager
class ATL_NO_VTABLE CKeypadManager : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CKeypadManager, &CLSID_KeypadManager>,
	public IDispatchImpl<IKeypadManager, &IID_IKeypadManager, &LIBID_ADSmartIO>
{
public:
	CKeypadManager();
	~CKeypadManager();

DECLARE_REGISTRY_RESOURCEID(IDR_KEYPADMANAGER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CKeypadManager)
	COM_INTERFACE_ENTRY(IKeypadManager)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IKeypadManager
public:
	STDMETHOD(get_ShowDebugMessages)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_ShowDebugMessages)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_KeypadColumns)(/*[out, retval]*/ int *pVal);
	STDMETHOD(put_KeypadColumns)(/*[in]*/ int newVal);
	STDMETHOD(get_KeypadRows)(/*[out, retval]*/ int *pVal);
	STDMETHOD(put_KeypadRows)(/*[in]*/ int newVal);
	STDMETHOD(get_KeypadRepeat)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_KeypadRepeat)(/*[in]*/ long newVal);
	STDMETHOD(get_KeypadDelay)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_KeypadDelay)(/*[in]*/ long newVal);
	STDMETHOD(ClearKeypadMap)();
	STDMETHOD(MapKeypad)(/*[in]*/ int KeyNumber, /*[in]*/ int KeyAscii);
	STDMETHOD(DisableKeypad)();
	STDMETHOD(EnableKeypad)();

private:
	static DWORD WINAPI ThreadMarshal(LPVOID pParam);
	static void CALLBACK KeypadTimer(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime);
	void ScanKeypad();

	unsigned int	hScanTimer;
	long			lDelay;
	BYTE			lastKey;
	int				m_rows;
	int				m_cols;
};

#endif //__KEYPADMANAGER_H_
